/*
 *++
COPYRIGHT:
This file is part of the GSM Suite, a set of programs for
manipulating state machines in a graphical fashion.
Copyright (C) 1996, 1997  G. Andrew Mangogna.

LICENSE:
This program is free software; you can redistribute it and/or
modify it under the terms of the GNU General Public License
as published by the Free Software Foundation; either version 2
of the License, or (at your option) any later version.

This program is distributed in the hope that it will be useful,
but WITHOUT ANY WARRANTY; without even the implied warranty of
MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
GNU General Public License for more details.

You should have received a copy of the GNU General Public License
along with this program; if not, write to the
Free Software Foundation, Inc.,
59 Temple Place - Suite 330,
Boston, MA  02111-1307, USA.

MODULE:

$RCSfile: StateDefVisitor.h,v $
$Revision: 1.4 $
$Date: 1997/07/02 04:45:26 $

ABSTRACT:

CONDITIONAL COMPILATION:

MODIFICATION HISTORY:
$Log: StateDefVisitor.h,v $
Revision 1.4  1997/07/02 04:45:26  andrewm
Added copyright and license notices to the tops of the files.

Revision 1.3  1996/12/26 05:55:30  andrewm
Checkpoint, the compiler is working again.

Revision 1.2  1996/10/01 04:39:38  andrewm
checkpoint and revision

 * Revision 1.1  1996/09/22  01:18:50  andrewm
 * pre-alpha release
 *
 *--
 */
#ifndef _StateDefVisitor_h_
#define _StateDefVisitor_h_

/*
PRAGMAS
*/
#ifdef __GNUG__
#	pragma interface
#endif /* __GNUG__ */

/*
INCLUDE FILES
*/
#include <iostream.h>
#include <string>

#include "MachineVisitor.h"

/*
MACRO DEFINITIONS
*/

/*
CLASS DEFINITIONS
*/

class StateDefVisitor :
	public MachineVisitor
{
public:
	StateDefVisitor(string& filename, ostream& stream,
		bool line_directives = true) ;

	virtual void visit(Smachine *machine) ;
	virtual void visit(State *state) ;
	virtual void visit(Transition *transition) ;
	virtual void visit(Parameter *parameter) ;

private:
	string& _filename ;
	ostream& _codefile ;
	bool _line_directives ;
	string _prefix_name ;
	string _state_class ;
	string _event_class ;
} ;



#endif /* _StateDefVisitor_h_ */
